-- This module contains canned messages, so that other code can refer
-- to them by name and doesn't get messed up with Sentence constructors.
module Messages where

import Language

type Message = Sentence

msg_door_locked :: Message
msg_door_locked = DescriptiveSentence (noun N_door) [] [AJ_locked]

msg_opening_door :: Message
msg_opening_door = BasicSentence you (verb V_open) (noun N_door)

msg_where_close_door :: Message
msg_where_close_door = DirQuestion (verb V_close) (noun N_door)

msg_door_already_closed :: Message
msg_door_already_closed =
  DescriptiveSentence (noun N_door) [AV_already] [AJ_closed]

msg_door_is_broken :: Message
msg_door_is_broken = DescriptiveSentence (noun N_door) [] [AJ_broken]

msg_empty_doorway :: Message
msg_empty_doorway =
  BasicSentence that (verb V_is)
    (noun_count Indefinite $
     adjective AJ_empty $
     noun N_doorway)

msg_no_door_there :: Message
msg_no_door_there =
  BasicSentence that (negated $ verb V_is)
    (noun_count Indefinite $ noun N_door)

msg_strange_direction :: Message
msg_strange_direction =
  BasicSentence that (verb V_is)
    (noun_count Indefinite $ adjective AJ_strange $ noun N_direction)
